data:extend({
util.merge{data.raw.boiler.boiler,{
    name = "void-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    minable = {result = "void-boiler"},
--    max_health = 250,
--    target_temperature = 315,
--    energy_consumption = "3.6MW",
  }},

  {
    type = "item",
    name = "void-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]",
    place_result = "void-boiler",
    stack_size = 50
  },
  {
    type = "recipe",
    name = "void-boiler",
    ingredients =
    {
      {"stone-furnace", 1},
      {"pipe", 4}
    },
    result = "void-boiler"
  },


util.merge{data.raw.boiler.boiler,{
    name = "fluid-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    minable = {result = "fluid-boiler"},
--    max_health = 250,
--    target_temperature = 315,
    energy_consumption = "2.7MW",
  }},

  {
    type = "item",
    name = "fluid-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]",
    place_result = "fluid-boiler",
    stack_size = 50
  },
  {
    type = "recipe",
    name = "fluid-boiler",
    ingredients =
    {
      {"stone-furnace", 1},
      {"pipe", 4}
    },
    result = "fluid-boiler"
  },


util.merge{data.raw.boiler.boiler,{
    name = "steam-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    minable = {result = "steam-boiler"},
--    max_health = 250,
--    target_temperature = 315,
--    energy_consumption = "3.6MW",
  }},

  {
    type = "item",
    name = "steam-boiler",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]",
    place_result = "steam-boiler",
    stack_size = 50
  },
  {
    type = "recipe",
    name = "steam-boiler",
    ingredients =
    {
      {"stone-furnace", 1},
      {"pipe", 4}
    },
    result = "steam-boiler"
  },
})

data.raw.boiler["void-boiler"].energy_source =
    {
      type = "void",
    }

data.raw.boiler["fluid-boiler"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      emissions_per_second_per_watt = 30 / 1800000,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {0, 1.5}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = true,
      scale_fluid_usage = true,
      fluid_usage_per_tick = 3,
      smoke =
      {
        {
          name = "smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 15,
          starting_vertical_speed = 0.0,
          starting_frame_deviation = 60
        }
      }
    }


data.raw.boiler["steam-boiler"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {0, 1.5}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }


data.raw.fluid.water.fuel_value = "1MJ"










data:extend({
util.merge{data.raw.inserter["burner-inserter"],{
    name = "steam-inserter",
    minable = {result = "steam-inserter"},
  }},
util.merge{data.raw.item["burner-inserter"],{
    name = "steam-inserter",
    place_result = "steam-inserter",
  }},
  {
    type = "recipe",
    name = "steam-inserter",
    ingredients = {},
    result = "steam-inserter"
  },
})


data:extend({
util.merge{data.raw["assembling-machine"]["assembling-machine-1"],{
    name = "steam-assembling-machine",
    minable = {result = "steam-assembling-machine"},
  }},
util.merge{data.raw.item["assembling-machine-1"],{
    name = "steam-assembling-machine",
    place_result = "steam-assembling-machine",
  }},
  {
    type = "recipe",
    name = "steam-assembling-machine",
    ingredients = {},
    result = "steam-assembling-machine"
  },
})

data:extend({
util.merge{data.raw["assembling-machine"]["assembling-machine-3"],{
    name = "steam-assembling-machine-3",
    minable = {result = "steam-assembling-machine-3"},
  }},
util.merge{data.raw.item["assembling-machine-3"],{
    name = "steam-assembling-machine-3",
    place_result = "steam-assembling-machine-3",
  }},
  {
    type = "recipe",
    name = "steam-assembling-machine-3",
    ingredients = {},
    result = "steam-assembling-machine-3"
  },
})


data:extend({
util.merge{data.raw["mining-drill"]["electric-mining-drill"],{
    name = "steam-mining-drill",
    minable = {result = "steam-mining-drill"},
  }},
util.merge{data.raw.item["electric-mining-drill"],{
    name = "steam-mining-drill",
    place_result = "steam-mining-drill",
  }},
  {
    type = "recipe",
    name = "steam-mining-drill",
    ingredients = {},
    result = "steam-mining-drill"
  },
})


data:extend({
util.merge{data.raw["lab"]["lab"],{
    name = "steam-lab",
    minable = {result = "steam-lab"},
  }},
util.merge{data.raw.item["lab"],{
    name = "steam-lab",
    place_result = "steam-lab",
  }},
  {
    type = "recipe",
    name = "steam-lab",
    ingredients = {},
    result = "steam-lab"
  },
})


data:extend({
util.merge{data.raw["radar"]["radar"],{
    name = "steam-radar",
    minable = {result = "steam-radar"},
  }},
util.merge{data.raw.item["radar"],{
    name = "steam-radar",
    place_result = "steam-radar",
  }},
  {
    type = "recipe",
    name = "steam-radar",
    ingredients = {},
    result = "steam-radar"
  },
})

data:extend({
util.merge{data.raw["furnace"]["electric-furnace"],{
    name = "steam-furnace",
    minable = {result = "steam-furnace"},
  }},
util.merge{data.raw.item["electric-furnace"],{
    name = "steam-furnace",
    place_result = "steam-furnace",
  }},
  {
    type = "recipe",
    name = "steam-furnace",
    ingredients = {},
    result = "steam-furnace"
  },
})

data:extend({
util.merge{data.raw["pump"]["pump"],{
    name = "steam-pump",
    minable = {result = "steam-pump"},
  }},
util.merge{data.raw.item["pump"],{
    name = "steam-pump",
    place_result = "steam-pump",
  }},
  {
    type = "recipe",
    name = "steam-pump",
    ingredients = {},
    result = "steam-pump"
  },
})




data.raw.inserter["steam-inserter"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {1, 0}},
          {type = "input-output", position = {-1, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }


data.raw["mining-drill"]["steam-mining-drill"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {2, 1}}
          
          ,{type = "input-output", position = {2, -1}}
          ,{type = "input-output", position = {-2, 1}}
          ,{type = "input-output", position = {-2, -1}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["assembling-machine"]["steam-assembling-machine"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {2, 0}}
          
          ,{type = "input-output", position = {-2, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["assembling-machine"]["steam-assembling-machine-3"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {2, 0}}
          
          ,{type = "input-output", position = {-2, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["lab"]["steam-lab"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {0, 2}}

          ,{type = "input-output", position = {0, -2}}
          ,{type = "input-output", position = {2, 0}}
          ,{type = "input-output", position = {-2, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["radar"]["steam-radar"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {0, 2}}

          ,{type = "input-output", position = {0, -2}}
          ,{type = "input-output", position = {2, 0}}
          ,{type = "input-output", position = {-2, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["furnace"]["steam-furnace"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {0, 2}}

          ,{type = "input-output", position = {0, -2}}
          ,{type = "input-output", position = {2, 0}}
          ,{type = "input-output", position = {-2, 0}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["pump"]["steam-pump"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 1,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {1, 0.5}},
          {type = "input-output", position = {-1, 0.5}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }







data:extend({
util.merge{data.raw.reactor["nuclear-reactor"],{
    name = "steam-reactor",
    minable = {result = "steam-reactor"},
    consumption = "10MW",
    scale_energy_usage = true,
    heat_buffer =
    {
      specific_heat = "1MJ",
    }
  }},
util.merge{data.raw.item["nuclear-reactor"],{
    name = "steam-reactor",
    place_result = "steam-reactor",
  }},
  {
    type = "recipe",
    name = "steam-reactor",
    ingredients = {},
    result = "steam-reactor"
  },
})

data.raw.reactor["steam-reactor"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      fluid_box =
      {
        base_area = 10,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {1, 3}},
          {type = "input-output", position = {-1, 3}},
          {type = "input-output", position = {1, -3}},
          {type = "input-output", position = {-1, -3}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = false,
      scale_fluid_usage = true,
      maximum_temperature = 165,
      smoke =
      {
        {
          name = "light-smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 10 / 32,
          starting_vertical_speed = 0.08,
          slow_down_factor = 1,
          starting_frame_deviation = 60
        }
      }
    }


data:extend({
util.merge{data.raw.reactor["nuclear-reactor"],{
    name = "fluid-reactor",
    minable = {result = "fluid-reactor"},
    consumption = "10MW",
    scale_energy_usage = true,
    heat_buffer =
    {
      specific_heat = "1MJ",
    }
  }},
util.merge{data.raw.item["nuclear-reactor"],{
    name = "fluid-reactor",
    place_result = "fluid-reactor",
  }},
  {
    type = "recipe",
    name = "fluid-reactor",
    ingredients = {},
    result = "fluid-reactor"
  },
})

data.raw.reactor["fluid-reactor"].energy_source =
    {
      type = "fluid",
      effectivity = 0.5,
      emissions_per_second_per_watt = 30 / 1800000,
      fluid_box =
      {
        base_area = 10,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          {type = "input-output", position = {1, 3}},
          {type = "input-output", position = {-1, 3}},
          {type = "input-output", position = {1, -3}},
          {type = "input-output", position = {-1, -3}}
        },
        pipe_covers = pipecoverspictures(),
        pipe_picture = assembler2pipepictures(),
        production_type = "input-output",
      },
      burns_fluid = true,
      scale_fluid_usage = true,
--      fluid_usage_per_tick = 2/60,
      smoke =
      {
        {
          name = "smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 15,
          starting_vertical_speed = 0.0,
          starting_frame_deviation = 60
        }
      }
    }


data.raw.recipe["heat-exchanger"].ingredients = {}
data.raw.recipe["heat-exchanger"].enabled = true
data.raw.recipe["heat-pipe"].ingredients = {}
data.raw.recipe["heat-pipe"].enabled = true




data:extend({
util.merge{data.raw["assembling-machine"]["assembling-machine-3"],{
    name = "assembling-machine-3-alt",
    never_sleep = true,
    minable = {result = "assembling-machine-3-alt"},
  }},
util.merge{data.raw.item["assembling-machine-3"],{
    name = "assembling-machine-3-alt",
    place_result = "assembling-machine-3-alt",
  }},
  {
    type = "recipe",
    name = "assembling-machine-3-alt",
    ingredients = {},
    result = "assembling-machine-3-alt"
  },
})

data.raw["assembling-machine"]["assembling-machine-3-alt"].energy_source =
    {
      type = "burner",
      effectivity = 0.5,
      emissions_per_second_per_watt = 30 / 1800000,
      fuel_inventory_size = 1,
      smoke =
      {
        {
          name = "smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 15,
          starting_vertical_speed = 0.0,
          starting_frame_deviation = 60
        }
      }
    }

data.raw["assembling-machine"]["assembling-machine-3-alt"].fluid_boxes =
    {
      {
        production_type = "input",
        pipe_picture = assembler3pipepictures(),
        pipe_covers = pipecoverspictures(),
        base_area = 10,
        height = 2,
        base_level = -1,
        pipe_connections =
        {
          { type="input-output", position = {-2, 0} }
          ,{ type="input-output", position = {2, 0} }
        },
        secondary_draw_orders = { north = -1 }
      },
      {
        production_type = "output",
        pipe_picture = assembler3pipepictures(),
        pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = 1,
        pipe_connections =
        {
          { type="output", position = {0, 2} }
        },
        secondary_draw_orders = { north = -1 }
      },
      off_when_no_fluid_recipe = true
    },

data:extend({
  {
    type = "recipe",
    name = "water-to-coal-magic",
    category = "crafting-with-fluid",
    ingredients =
    {
      {type = "fluid", name = "water", amount = 10},
    },
    result = "coal",
    icon = "__base__/graphics/icons/fluid/basic-oil-processing.png",
    icon_size = 32,
    subgroup = "fluid-recipes",
  }
})

data:extend({
util.merge{data.raw["assembling-machine"]["assembling-machine-3-alt"],{
    name = "assembling-machine-3-burner",
    never_sleep = false,
    minable = {result = "assembling-machine-3-burner"},
  }},
util.merge{data.raw.item["assembling-machine-3"],{
    name = "assembling-machine-3-burner",
    place_result = "assembling-machine-3-burner",
  }},
  {
    type = "recipe",
    name = "assembling-machine-3-burner",
    ingredients = {},
    result = "assembling-machine-3-burner"
  },
})
